/**
 * Copyright (c) 2020 fumeiai All rights reserved.
 *
 *
 *
 * 版权所有，侵权必究！
 */

package com.lz.common.utils;

import org.springframework.beans.BeansException;
import org.springframework.context.ApplicationContext;
import org.springframework.context.ApplicationContextAware;
import org.springframework.stereotype.Component;

/**
 * Spring Context 工具类
 *
 * @author Mark sunlightcs@gmail.com
 */
@Component
public class SpringContextUtils implements ApplicationContextAware {
	public static ApplicationContext applicationContext;

	@Override
	public void setApplicationContext(ApplicationContext applicationContext)
			throws BeansException {
		SpringContextUtils.applicationContext = applicationContext;
	}

	public static Object getBean(String name) {
		return applicationContext.getBean(name);
	}

	public static <T> T getBean(String name, Class<T> requiredType) {
		return applicationContext.getBean(name, requiredType);
	}

	public static boolean containsBean(String name) {
		return applicationContext.containsBean(name);
	}

	public static boolean isSingleton(String name) {
		return applicationContext.isSingleton(name);
	}

	public static Class<? extends Object> getType(String name) {
		return applicationContext.getType(name);
	}




	/// 获取当前环境
	public static boolean isSQLLogDebug() {
		if (Constant.INVELOMENT_TYPE_TEST.equals(getActiveProfile())
				|| Constant.INVELOMENT_TYPE_DEV.equals(getActiveProfile())
				|| Constant.INVELOMENT_TYPE_TEST1.equals(getActiveProfile())
				|| Constant.INVELOMENT_TYPE_TEST2.equals(getActiveProfile())
				|| Constant.INVELOMENT_TYPE_TEST3.equals(getActiveProfile())
		) {
			return true;
		}
		return true;
	}


	/// 获取当前环境
	public static boolean isDataLogDebug() {
		if (Constant.INVELOMENT_TYPE_TEST.equals(getActiveProfile())
				|| Constant.INVELOMENT_TYPE_DEV.equals(getActiveProfile())
				|| Constant.INVELOMENT_TYPE_TEST2.equals(getActiveProfile())
				|| Constant.INVELOMENT_TYPE_TEST3.equals(getActiveProfile())
		) {
			return true;
		}
		return false;
	}
	/// 获取当前环境
	public static String getActiveProfile() {
		if (applicationContext != null) {
			return applicationContext.getEnvironment().getActiveProfiles()[0];
		}
		return null;
	}


	/// 获取当前环境
	public static boolean isTestDev() {
		if (Constant.INVELOMENT_TYPE_TEST.equals(getActiveProfile())
				|| Constant.INVELOMENT_TYPE_DEV.equals(getActiveProfile())
				|| Constant.INVELOMENT_TYPE_TEST2.equals(getActiveProfile())
				|| Constant.INVELOMENT_TYPE_TEST3.equals(getActiveProfile())
		) {
			return true;
		}
		return false;
	}
}
